# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'CloudRunConfigLoadBalancerType',
    'ClusterStatus',
    'ClusterUpdateDesiredPrivateIpv6GoogleAccess',
    'DatabaseEncryptionState',
    'NetworkConfigPrivateIpv6GoogleAccess',
    'NetworkPolicyProvider',
    'NodePoolStatus',
    'NodeTaintEffect',
    'ReleaseChannelChannel',
    'ReservationAffinityConsumeReservationType',
    'SandboxConfigType',
    'StatusConditionCanonicalCode',
    'WorkloadMetadataConfigMode',
]


class CloudRunConfigLoadBalancerType(str, Enum):
    """
    Which load balancer type is installed for Cloud Run.
    """
    LOAD_BALANCER_TYPE_UNSPECIFIED = "LOAD_BALANCER_TYPE_UNSPECIFIED"
    LOAD_BALANCER_TYPE_EXTERNAL = "LOAD_BALANCER_TYPE_EXTERNAL"
    LOAD_BALANCER_TYPE_INTERNAL = "LOAD_BALANCER_TYPE_INTERNAL"


class ClusterStatus(str, Enum):
    """
    [Output only] The current status of this cluster.
    """
    STATUS_UNSPECIFIED = "STATUS_UNSPECIFIED"
    PROVISIONING = "PROVISIONING"
    RUNNING = "RUNNING"
    RECONCILING = "RECONCILING"
    STOPPING = "STOPPING"
    ERROR = "ERROR"
    DEGRADED = "DEGRADED"


class ClusterUpdateDesiredPrivateIpv6GoogleAccess(str, Enum):
    """
    The desired state of IPv6 connectivity to Google Services.
    """
    PRIVATE_IPV6_GOOGLE_ACCESS_UNSPECIFIED = "PRIVATE_IPV6_GOOGLE_ACCESS_UNSPECIFIED"
    PRIVATE_IPV6_GOOGLE_ACCESS_DISABLED = "PRIVATE_IPV6_GOOGLE_ACCESS_DISABLED"
    PRIVATE_IPV6_GOOGLE_ACCESS_TO_GOOGLE = "PRIVATE_IPV6_GOOGLE_ACCESS_TO_GOOGLE"
    PRIVATE_IPV6_GOOGLE_ACCESS_BIDIRECTIONAL = "PRIVATE_IPV6_GOOGLE_ACCESS_BIDIRECTIONAL"


class DatabaseEncryptionState(str, Enum):
    """
    Denotes the state of etcd encryption.
    """
    UNKNOWN = "UNKNOWN"
    ENCRYPTED = "ENCRYPTED"
    DECRYPTED = "DECRYPTED"


class NetworkConfigPrivateIpv6GoogleAccess(str, Enum):
    """
    The desired state of IPv6 connectivity to Google Services. By default, no private IPv6 access to or from Google Services (all access will be via IPv4)
    """
    PRIVATE_IPV6_GOOGLE_ACCESS_UNSPECIFIED = "PRIVATE_IPV6_GOOGLE_ACCESS_UNSPECIFIED"
    PRIVATE_IPV6_GOOGLE_ACCESS_DISABLED = "PRIVATE_IPV6_GOOGLE_ACCESS_DISABLED"
    PRIVATE_IPV6_GOOGLE_ACCESS_TO_GOOGLE = "PRIVATE_IPV6_GOOGLE_ACCESS_TO_GOOGLE"
    PRIVATE_IPV6_GOOGLE_ACCESS_BIDIRECTIONAL = "PRIVATE_IPV6_GOOGLE_ACCESS_BIDIRECTIONAL"


class NetworkPolicyProvider(str, Enum):
    """
    The selected network policy provider.
    """
    PROVIDER_UNSPECIFIED = "PROVIDER_UNSPECIFIED"
    CALICO = "CALICO"


class NodePoolStatus(str, Enum):
    """
    [Output only] The status of the nodes in this pool instance.
    """
    STATUS_UNSPECIFIED = "STATUS_UNSPECIFIED"
    PROVISIONING = "PROVISIONING"
    RUNNING = "RUNNING"
    RUNNING_WITH_ERROR = "RUNNING_WITH_ERROR"
    RECONCILING = "RECONCILING"
    STOPPING = "STOPPING"
    ERROR = "ERROR"


class NodeTaintEffect(str, Enum):
    """
    Effect for taint.
    """
    EFFECT_UNSPECIFIED = "EFFECT_UNSPECIFIED"
    NO_SCHEDULE = "NO_SCHEDULE"
    PREFER_NO_SCHEDULE = "PREFER_NO_SCHEDULE"
    NO_EXECUTE = "NO_EXECUTE"


class ReleaseChannelChannel(str, Enum):
    """
    channel specifies which release channel the cluster is subscribed to.
    """
    UNSPECIFIED = "UNSPECIFIED"
    RAPID = "RAPID"
    REGULAR = "REGULAR"
    STABLE = "STABLE"


class ReservationAffinityConsumeReservationType(str, Enum):
    """
    Corresponds to the type of reservation consumption.
    """
    UNSPECIFIED = "UNSPECIFIED"
    NO_RESERVATION = "NO_RESERVATION"
    ANY_RESERVATION = "ANY_RESERVATION"
    SPECIFIC_RESERVATION = "SPECIFIC_RESERVATION"


class SandboxConfigType(str, Enum):
    """
    Type of the sandbox to use for the node.
    """
    UNSPECIFIED = "UNSPECIFIED"
    GVISOR = "GVISOR"


class StatusConditionCanonicalCode(str, Enum):
    """
    Canonical code of the condition.
    """
    OK = "OK"
    CANCELLED = "CANCELLED"
    UNKNOWN = "UNKNOWN"
    INVALID_ARGUMENT = "INVALID_ARGUMENT"
    DEADLINE_EXCEEDED = "DEADLINE_EXCEEDED"
    NOT_FOUND = "NOT_FOUND"
    ALREADY_EXISTS = "ALREADY_EXISTS"
    PERMISSION_DENIED = "PERMISSION_DENIED"
    UNAUTHENTICATED = "UNAUTHENTICATED"
    RESOURCE_EXHAUSTED = "RESOURCE_EXHAUSTED"
    FAILED_PRECONDITION = "FAILED_PRECONDITION"
    ABORTED = "ABORTED"
    OUT_OF_RANGE = "OUT_OF_RANGE"
    UNIMPLEMENTED = "UNIMPLEMENTED"
    INTERNAL = "INTERNAL"
    UNAVAILABLE = "UNAVAILABLE"
    DATA_LOSS = "DATA_LOSS"


class WorkloadMetadataConfigMode(str, Enum):
    """
    Mode is the configuration for how to expose metadata to workloads running on the node pool.
    """
    MODE_UNSPECIFIED = "MODE_UNSPECIFIED"
    GCE_METADATA = "GCE_METADATA"
    GKE_METADATA = "GKE_METADATA"
