# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'CloudRunConfigLoadBalancerType',
    'ClusterAutoscalingAutoscalingProfile',
    'ClusterStatus',
    'ClusterTelemetryType',
    'ClusterUpdateDesiredDatapathProvider',
    'ClusterUpdateDesiredPrivateIpv6GoogleAccess',
    'DatabaseEncryptionState',
    'IstioConfigAuth',
    'NetworkConfigDatapathProvider',
    'NetworkConfigPrivateIpv6GoogleAccess',
    'NetworkPolicyProvider',
    'NodePoolStatus',
    'NodeTaintEffect',
    'ReleaseChannelChannel',
    'ReservationAffinityConsumeReservationType',
    'SandboxConfigType',
    'StatusConditionCanonicalCode',
    'WorkloadMetadataConfigMode',
    'WorkloadMetadataConfigNodeMetadata',
]


class CloudRunConfigLoadBalancerType(str, Enum):
    """
    Which load balancer type is installed for Cloud Run.
    """
    LOAD_BALANCER_TYPE_UNSPECIFIED = "LOAD_BALANCER_TYPE_UNSPECIFIED"
    LOAD_BALANCER_TYPE_EXTERNAL = "LOAD_BALANCER_TYPE_EXTERNAL"
    LOAD_BALANCER_TYPE_INTERNAL = "LOAD_BALANCER_TYPE_INTERNAL"


class ClusterAutoscalingAutoscalingProfile(str, Enum):
    """
    Defines autoscaling behaviour.
    """
    PROFILE_UNSPECIFIED = "PROFILE_UNSPECIFIED"
    OPTIMIZE_UTILIZATION = "OPTIMIZE_UTILIZATION"
    BALANCED = "BALANCED"


class ClusterStatus(str, Enum):
    """
    [Output only] The current status of this cluster.
    """
    STATUS_UNSPECIFIED = "STATUS_UNSPECIFIED"
    PROVISIONING = "PROVISIONING"
    RUNNING = "RUNNING"
    RECONCILING = "RECONCILING"
    STOPPING = "STOPPING"
    ERROR = "ERROR"
    DEGRADED = "DEGRADED"


class ClusterTelemetryType(str, Enum):
    """
    Type of the integration.
    """
    UNSPECIFIED = "UNSPECIFIED"
    DISABLED = "DISABLED"
    ENABLED = "ENABLED"
    SYSTEM_ONLY = "SYSTEM_ONLY"


class ClusterUpdateDesiredDatapathProvider(str, Enum):
    """
    The desired datapath provider for the cluster.
    """
    DATAPATH_PROVIDER_UNSPECIFIED = "DATAPATH_PROVIDER_UNSPECIFIED"
    LEGACY_DATAPATH = "LEGACY_DATAPATH"
    ADVANCED_DATAPATH = "ADVANCED_DATAPATH"


class ClusterUpdateDesiredPrivateIpv6GoogleAccess(str, Enum):
    """
    The desired state of IPv6 connectivity to Google Services.
    """
    PRIVATE_IPV6_GOOGLE_ACCESS_UNSPECIFIED = "PRIVATE_IPV6_GOOGLE_ACCESS_UNSPECIFIED"
    PRIVATE_IPV6_GOOGLE_ACCESS_DISABLED = "PRIVATE_IPV6_GOOGLE_ACCESS_DISABLED"
    PRIVATE_IPV6_GOOGLE_ACCESS_TO_GOOGLE = "PRIVATE_IPV6_GOOGLE_ACCESS_TO_GOOGLE"
    PRIVATE_IPV6_GOOGLE_ACCESS_BIDIRECTIONAL = "PRIVATE_IPV6_GOOGLE_ACCESS_BIDIRECTIONAL"


class DatabaseEncryptionState(str, Enum):
    """
    Denotes the state of etcd encryption.
    """
    UNKNOWN = "UNKNOWN"
    ENCRYPTED = "ENCRYPTED"
    DECRYPTED = "DECRYPTED"


class IstioConfigAuth(str, Enum):
    """
    The specified Istio auth mode, either none, or mutual TLS.
    """
    AUTH_NONE = "AUTH_NONE"
    AUTH_MUTUAL_TLS = "AUTH_MUTUAL_TLS"


class NetworkConfigDatapathProvider(str, Enum):
    """
    The desired datapath provider for this cluster. By default, uses the IPTables-based kube-proxy implementation.
    """
    DATAPATH_PROVIDER_UNSPECIFIED = "DATAPATH_PROVIDER_UNSPECIFIED"
    LEGACY_DATAPATH = "LEGACY_DATAPATH"
    ADVANCED_DATAPATH = "ADVANCED_DATAPATH"


class NetworkConfigPrivateIpv6GoogleAccess(str, Enum):
    """
    The desired state of IPv6 connectivity to Google Services. By default, no private IPv6 access to or from Google Services (all access will be via IPv4)
    """
    PRIVATE_IPV6_GOOGLE_ACCESS_UNSPECIFIED = "PRIVATE_IPV6_GOOGLE_ACCESS_UNSPECIFIED"
    PRIVATE_IPV6_GOOGLE_ACCESS_DISABLED = "PRIVATE_IPV6_GOOGLE_ACCESS_DISABLED"
    PRIVATE_IPV6_GOOGLE_ACCESS_TO_GOOGLE = "PRIVATE_IPV6_GOOGLE_ACCESS_TO_GOOGLE"
    PRIVATE_IPV6_GOOGLE_ACCESS_BIDIRECTIONAL = "PRIVATE_IPV6_GOOGLE_ACCESS_BIDIRECTIONAL"


class NetworkPolicyProvider(str, Enum):
    """
    The selected network policy provider.
    """
    PROVIDER_UNSPECIFIED = "PROVIDER_UNSPECIFIED"
    CALICO = "CALICO"


class NodePoolStatus(str, Enum):
    """
    [Output only] The status of the nodes in this pool instance.
    """
    STATUS_UNSPECIFIED = "STATUS_UNSPECIFIED"
    PROVISIONING = "PROVISIONING"
    RUNNING = "RUNNING"
    RUNNING_WITH_ERROR = "RUNNING_WITH_ERROR"
    RECONCILING = "RECONCILING"
    STOPPING = "STOPPING"
    ERROR = "ERROR"


class NodeTaintEffect(str, Enum):
    """
    Effect for taint.
    """
    EFFECT_UNSPECIFIED = "EFFECT_UNSPECIFIED"
    NO_SCHEDULE = "NO_SCHEDULE"
    PREFER_NO_SCHEDULE = "PREFER_NO_SCHEDULE"
    NO_EXECUTE = "NO_EXECUTE"


class ReleaseChannelChannel(str, Enum):
    """
    channel specifies which release channel the cluster is subscribed to.
    """
    UNSPECIFIED = "UNSPECIFIED"
    RAPID = "RAPID"
    REGULAR = "REGULAR"
    STABLE = "STABLE"


class ReservationAffinityConsumeReservationType(str, Enum):
    """
    Corresponds to the type of reservation consumption.
    """
    UNSPECIFIED = "UNSPECIFIED"
    NO_RESERVATION = "NO_RESERVATION"
    ANY_RESERVATION = "ANY_RESERVATION"
    SPECIFIC_RESERVATION = "SPECIFIC_RESERVATION"


class SandboxConfigType(str, Enum):
    """
    Type of the sandbox to use for the node.
    """
    UNSPECIFIED = "UNSPECIFIED"
    GVISOR = "GVISOR"


class StatusConditionCanonicalCode(str, Enum):
    """
    Canonical code of the condition.
    """
    OK = "OK"
    CANCELLED = "CANCELLED"
    UNKNOWN = "UNKNOWN"
    INVALID_ARGUMENT = "INVALID_ARGUMENT"
    DEADLINE_EXCEEDED = "DEADLINE_EXCEEDED"
    NOT_FOUND = "NOT_FOUND"
    ALREADY_EXISTS = "ALREADY_EXISTS"
    PERMISSION_DENIED = "PERMISSION_DENIED"
    UNAUTHENTICATED = "UNAUTHENTICATED"
    RESOURCE_EXHAUSTED = "RESOURCE_EXHAUSTED"
    FAILED_PRECONDITION = "FAILED_PRECONDITION"
    ABORTED = "ABORTED"
    OUT_OF_RANGE = "OUT_OF_RANGE"
    UNIMPLEMENTED = "UNIMPLEMENTED"
    INTERNAL = "INTERNAL"
    UNAVAILABLE = "UNAVAILABLE"
    DATA_LOSS = "DATA_LOSS"


class WorkloadMetadataConfigMode(str, Enum):
    """
    Mode is the configuration for how to expose metadata to workloads running on the node pool.
    """
    MODE_UNSPECIFIED = "MODE_UNSPECIFIED"
    GCE_METADATA = "GCE_METADATA"
    GKE_METADATA = "GKE_METADATA"


class WorkloadMetadataConfigNodeMetadata(str, Enum):
    """
    NodeMetadata is the configuration for how to expose metadata to the workloads running on the node.
    """
    UNSPECIFIED = "UNSPECIFIED"
    SECURE = "SECURE"
    EXPOSE = "EXPOSE"
    GKE_METADATA_SERVER = "GKE_METADATA_SERVER"
