# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AutoscalingSettingsAlgorithm',
    'EnvironmentFlexResourceSchedulingGoal',
    'ExecutionStageStateExecutionStageState',
    'ExecutionStageSummaryKind',
    'JobCurrentState',
    'JobRequestedState',
    'JobType',
    'RuntimeEnvironmentIpConfiguration',
    'SdkVersionSdkSupportStatus',
    'TransformSummaryKind',
    'WorkerPoolDefaultPackageSet',
    'WorkerPoolIpConfiguration',
    'WorkerPoolTeardownPolicy',
]


class AutoscalingSettingsAlgorithm(str, Enum):
    """
    The algorithm to use for autoscaling.
    """
    AUTOSCALING_ALGORITHM_UNKNOWN = "AUTOSCALING_ALGORITHM_UNKNOWN"
    AUTOSCALING_ALGORITHM_NONE = "AUTOSCALING_ALGORITHM_NONE"
    AUTOSCALING_ALGORITHM_BASIC = "AUTOSCALING_ALGORITHM_BASIC"


class EnvironmentFlexResourceSchedulingGoal(str, Enum):
    """
    Which Flexible Resource Scheduling mode to run in.
    """
    FLEXRS_UNSPECIFIED = "FLEXRS_UNSPECIFIED"
    FLEXRS_SPEED_OPTIMIZED = "FLEXRS_SPEED_OPTIMIZED"
    FLEXRS_COST_OPTIMIZED = "FLEXRS_COST_OPTIMIZED"


class ExecutionStageStateExecutionStageState(str, Enum):
    """
    Executions stage states allow the same set of values as JobState.
    """
    JOB_STATE_UNKNOWN = "JOB_STATE_UNKNOWN"
    JOB_STATE_STOPPED = "JOB_STATE_STOPPED"
    JOB_STATE_RUNNING = "JOB_STATE_RUNNING"
    JOB_STATE_DONE = "JOB_STATE_DONE"
    JOB_STATE_FAILED = "JOB_STATE_FAILED"
    JOB_STATE_CANCELLED = "JOB_STATE_CANCELLED"
    JOB_STATE_UPDATED = "JOB_STATE_UPDATED"
    JOB_STATE_DRAINING = "JOB_STATE_DRAINING"
    JOB_STATE_DRAINED = "JOB_STATE_DRAINED"
    JOB_STATE_PENDING = "JOB_STATE_PENDING"
    JOB_STATE_CANCELLING = "JOB_STATE_CANCELLING"
    JOB_STATE_QUEUED = "JOB_STATE_QUEUED"
    JOB_STATE_RESOURCE_CLEANING_UP = "JOB_STATE_RESOURCE_CLEANING_UP"


class ExecutionStageSummaryKind(str, Enum):
    """
    Type of transform this stage is executing.
    """
    UNKNOWN_KIND = "UNKNOWN_KIND"
    PAR_DO_KIND = "PAR_DO_KIND"
    GROUP_BY_KEY_KIND = "GROUP_BY_KEY_KIND"
    FLATTEN_KIND = "FLATTEN_KIND"
    READ_KIND = "READ_KIND"
    WRITE_KIND = "WRITE_KIND"
    CONSTANT_KIND = "CONSTANT_KIND"
    SINGLETON_KIND = "SINGLETON_KIND"
    SHUFFLE_KIND = "SHUFFLE_KIND"


class JobCurrentState(str, Enum):
    """
    The current state of the job. Jobs are created in the `JOB_STATE_STOPPED` state unless otherwise specified. A job in the `JOB_STATE_RUNNING` state may asynchronously enter a terminal state. After a job has reached a terminal state, no further state updates may be made. This field may be mutated by the Cloud Dataflow service; callers cannot mutate it.
    """
    JOB_STATE_UNKNOWN = "JOB_STATE_UNKNOWN"
    JOB_STATE_STOPPED = "JOB_STATE_STOPPED"
    JOB_STATE_RUNNING = "JOB_STATE_RUNNING"
    JOB_STATE_DONE = "JOB_STATE_DONE"
    JOB_STATE_FAILED = "JOB_STATE_FAILED"
    JOB_STATE_CANCELLED = "JOB_STATE_CANCELLED"
    JOB_STATE_UPDATED = "JOB_STATE_UPDATED"
    JOB_STATE_DRAINING = "JOB_STATE_DRAINING"
    JOB_STATE_DRAINED = "JOB_STATE_DRAINED"
    JOB_STATE_PENDING = "JOB_STATE_PENDING"
    JOB_STATE_CANCELLING = "JOB_STATE_CANCELLING"
    JOB_STATE_QUEUED = "JOB_STATE_QUEUED"
    JOB_STATE_RESOURCE_CLEANING_UP = "JOB_STATE_RESOURCE_CLEANING_UP"


class JobRequestedState(str, Enum):
    """
    The job's requested state. `UpdateJob` may be used to switch between the `JOB_STATE_STOPPED` and `JOB_STATE_RUNNING` states, by setting requested_state. `UpdateJob` may also be used to directly set a job's requested state to `JOB_STATE_CANCELLED` or `JOB_STATE_DONE`, irrevocably terminating the job if it has not already reached a terminal state.
    """
    JOB_STATE_UNKNOWN = "JOB_STATE_UNKNOWN"
    JOB_STATE_STOPPED = "JOB_STATE_STOPPED"
    JOB_STATE_RUNNING = "JOB_STATE_RUNNING"
    JOB_STATE_DONE = "JOB_STATE_DONE"
    JOB_STATE_FAILED = "JOB_STATE_FAILED"
    JOB_STATE_CANCELLED = "JOB_STATE_CANCELLED"
    JOB_STATE_UPDATED = "JOB_STATE_UPDATED"
    JOB_STATE_DRAINING = "JOB_STATE_DRAINING"
    JOB_STATE_DRAINED = "JOB_STATE_DRAINED"
    JOB_STATE_PENDING = "JOB_STATE_PENDING"
    JOB_STATE_CANCELLING = "JOB_STATE_CANCELLING"
    JOB_STATE_QUEUED = "JOB_STATE_QUEUED"
    JOB_STATE_RESOURCE_CLEANING_UP = "JOB_STATE_RESOURCE_CLEANING_UP"


class JobType(str, Enum):
    """
    The type of Cloud Dataflow job.
    """
    JOB_TYPE_UNKNOWN = "JOB_TYPE_UNKNOWN"
    JOB_TYPE_BATCH = "JOB_TYPE_BATCH"
    JOB_TYPE_STREAMING = "JOB_TYPE_STREAMING"


class RuntimeEnvironmentIpConfiguration(str, Enum):
    """
    Configuration for VM IPs.
    """
    WORKER_IP_UNSPECIFIED = "WORKER_IP_UNSPECIFIED"
    WORKER_IP_PUBLIC = "WORKER_IP_PUBLIC"
    WORKER_IP_PRIVATE = "WORKER_IP_PRIVATE"


class SdkVersionSdkSupportStatus(str, Enum):
    """
    The support status for this SDK version.
    """
    UNKNOWN = "UNKNOWN"
    SUPPORTED = "SUPPORTED"
    STALE = "STALE"
    DEPRECATED = "DEPRECATED"
    UNSUPPORTED = "UNSUPPORTED"


class TransformSummaryKind(str, Enum):
    """
    Type of transform.
    """
    UNKNOWN_KIND = "UNKNOWN_KIND"
    PAR_DO_KIND = "PAR_DO_KIND"
    GROUP_BY_KEY_KIND = "GROUP_BY_KEY_KIND"
    FLATTEN_KIND = "FLATTEN_KIND"
    READ_KIND = "READ_KIND"
    WRITE_KIND = "WRITE_KIND"
    CONSTANT_KIND = "CONSTANT_KIND"
    SINGLETON_KIND = "SINGLETON_KIND"
    SHUFFLE_KIND = "SHUFFLE_KIND"


class WorkerPoolDefaultPackageSet(str, Enum):
    """
    The default package set to install. This allows the service to select a default set of packages which are useful to worker harnesses written in a particular language.
    """
    DEFAULT_PACKAGE_SET_UNKNOWN = "DEFAULT_PACKAGE_SET_UNKNOWN"
    DEFAULT_PACKAGE_SET_NONE = "DEFAULT_PACKAGE_SET_NONE"
    DEFAULT_PACKAGE_SET_JAVA = "DEFAULT_PACKAGE_SET_JAVA"
    DEFAULT_PACKAGE_SET_PYTHON = "DEFAULT_PACKAGE_SET_PYTHON"


class WorkerPoolIpConfiguration(str, Enum):
    """
    Configuration for VM IPs.
    """
    WORKER_IP_UNSPECIFIED = "WORKER_IP_UNSPECIFIED"
    WORKER_IP_PUBLIC = "WORKER_IP_PUBLIC"
    WORKER_IP_PRIVATE = "WORKER_IP_PRIVATE"


class WorkerPoolTeardownPolicy(str, Enum):
    """
    Sets the policy for determining when to turndown worker pool. Allowed values are: `TEARDOWN_ALWAYS`, `TEARDOWN_ON_SUCCESS`, and `TEARDOWN_NEVER`. `TEARDOWN_ALWAYS` means workers are always torn down regardless of whether the job succeeds. `TEARDOWN_ON_SUCCESS` means workers are torn down if the job succeeds. `TEARDOWN_NEVER` means the workers are never torn down. If the workers are not torn down by the service, they will continue to run and use Google Compute Engine VM resources in the user's project until they are explicitly terminated by the user. Because of this, Google recommends using the `TEARDOWN_ALWAYS` policy except for small, manually supervised test jobs. If unknown or unspecified, the service will attempt to choose a reasonable default.
    """
    TEARDOWN_POLICY_UNKNOWN = "TEARDOWN_POLICY_UNKNOWN"
    TEARDOWN_ALWAYS = "TEARDOWN_ALWAYS"
    TEARDOWN_ON_SUCCESS = "TEARDOWN_ON_SUCCESS"
    TEARDOWN_NEVER = "TEARDOWN_NEVER"
