# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'ConversationConversationStage',
    'DocumentKnowledgeTypesItem',
    'EntityTypeAutoExpansionMode',
    'EntityTypeKind',
    'GoogleCloudDialogflowV2FulfillmentFeatureType',
    'GoogleCloudDialogflowV2IntentMessageBrowseCarouselCardBrowseCarouselCardItemOpenUrlActionUrlTypeHint',
    'GoogleCloudDialogflowV2IntentMessageBrowseCarouselCardImageDisplayOptions',
    'GoogleCloudDialogflowV2IntentMessageColumnPropertiesHorizontalAlignment',
    'GoogleCloudDialogflowV2IntentMessageMediaContentMediaType',
    'GoogleCloudDialogflowV2IntentMessagePlatform',
    'GoogleCloudDialogflowV2IntentTrainingPhraseType',
    'GoogleCloudDialogflowV2NotificationConfigMessageFormat',
    'GoogleCloudDialogflowV2SpeechToTextConfigSpeechModelVariant',
    'GoogleCloudDialogflowV2SuggestionFeatureType',
    'GoogleCloudDialogflowV2TextToSpeechSettingsOutputAudioEncoding',
    'IntentDefaultResponsePlatformsItem',
    'IntentWebhookState',
    'ParticipantRole',
    'SessionEntityTypeEntityOverrideMode',
]


class ConversationConversationStage(str, Enum):
    """
    The stage of a conversation. It indicates whether the virtual agent or a human agent is handling the conversation. If the conversation is created with the conversation profile that has Dialogflow config set, defaults to ConversationStage.VIRTUAL_AGENT_STAGE; Otherwise, defaults to ConversationStage.HUMAN_ASSIST_STAGE. If the conversation is created with the conversation profile that has Dialogflow config set but explicitly sets conversation_stage to ConversationStage.HUMAN_ASSIST_STAGE, it skips ConversationStage.VIRTUAL_AGENT_STAGE stage and directly goes to ConversationStage.HUMAN_ASSIST_STAGE.
    """
    CONVERSATION_STAGE_UNSPECIFIED = "CONVERSATION_STAGE_UNSPECIFIED"
    VIRTUAL_AGENT_STAGE = "VIRTUAL_AGENT_STAGE"
    HUMAN_ASSIST_STAGE = "HUMAN_ASSIST_STAGE"


class DocumentKnowledgeTypesItem(str, Enum):
    KNOWLEDGE_TYPE_UNSPECIFIED = "KNOWLEDGE_TYPE_UNSPECIFIED"
    FAQ = "FAQ"
    EXTRACTIVE_QA = "EXTRACTIVE_QA"
    ARTICLE_SUGGESTION = "ARTICLE_SUGGESTION"


class EntityTypeAutoExpansionMode(str, Enum):
    """
    Optional. Indicates whether the entity type can be automatically expanded.
    """
    AUTO_EXPANSION_MODE_UNSPECIFIED = "AUTO_EXPANSION_MODE_UNSPECIFIED"
    AUTO_EXPANSION_MODE_DEFAULT = "AUTO_EXPANSION_MODE_DEFAULT"


class EntityTypeKind(str, Enum):
    """
    Required. Indicates the kind of entity type.
    """
    KIND_UNSPECIFIED = "KIND_UNSPECIFIED"
    KIND_MAP = "KIND_MAP"
    KIND_LIST = "KIND_LIST"
    KIND_REGEXP = "KIND_REGEXP"


class GoogleCloudDialogflowV2FulfillmentFeatureType(str, Enum):
    """
    The type of the feature that enabled for fulfillment.
    """
    TYPE_UNSPECIFIED = "TYPE_UNSPECIFIED"
    SMALLTALK = "SMALLTALK"


class GoogleCloudDialogflowV2IntentMessageBrowseCarouselCardBrowseCarouselCardItemOpenUrlActionUrlTypeHint(str, Enum):
    """
    Optional. Specifies the type of viewer that is used when opening the URL. Defaults to opening via web browser.
    """
    URL_TYPE_HINT_UNSPECIFIED = "URL_TYPE_HINT_UNSPECIFIED"
    AMP_ACTION = "AMP_ACTION"
    AMP_CONTENT = "AMP_CONTENT"


class GoogleCloudDialogflowV2IntentMessageBrowseCarouselCardImageDisplayOptions(str, Enum):
    """
    Optional. Settings for displaying the image. Applies to every image in items.
    """
    IMAGE_DISPLAY_OPTIONS_UNSPECIFIED = "IMAGE_DISPLAY_OPTIONS_UNSPECIFIED"
    GRAY = "GRAY"
    WHITE = "WHITE"
    CROPPED = "CROPPED"
    BLURRED_BACKGROUND = "BLURRED_BACKGROUND"


class GoogleCloudDialogflowV2IntentMessageColumnPropertiesHorizontalAlignment(str, Enum):
    """
    Optional. Defines text alignment for all cells in this column.
    """
    HORIZONTAL_ALIGNMENT_UNSPECIFIED = "HORIZONTAL_ALIGNMENT_UNSPECIFIED"
    LEADING = "LEADING"
    CENTER = "CENTER"
    TRAILING = "TRAILING"


class GoogleCloudDialogflowV2IntentMessageMediaContentMediaType(str, Enum):
    """
    Optional. What type of media is the content (ie "audio").
    """
    RESPONSE_MEDIA_TYPE_UNSPECIFIED = "RESPONSE_MEDIA_TYPE_UNSPECIFIED"
    AUDIO = "AUDIO"


class GoogleCloudDialogflowV2IntentMessagePlatform(str, Enum):
    """
    Optional. The platform that this message is intended for.
    """
    PLATFORM_UNSPECIFIED = "PLATFORM_UNSPECIFIED"
    FACEBOOK = "FACEBOOK"
    SLACK = "SLACK"
    TELEGRAM = "TELEGRAM"
    KIK = "KIK"
    SKYPE = "SKYPE"
    LINE = "LINE"
    VIBER = "VIBER"
    ACTIONS_ON_GOOGLE = "ACTIONS_ON_GOOGLE"
    GOOGLE_HANGOUTS = "GOOGLE_HANGOUTS"


class GoogleCloudDialogflowV2IntentTrainingPhraseType(str, Enum):
    """
    Required. The type of the training phrase.
    """
    TYPE_UNSPECIFIED = "TYPE_UNSPECIFIED"
    EXAMPLE = "EXAMPLE"
    TEMPLATE = "TEMPLATE"


class GoogleCloudDialogflowV2NotificationConfigMessageFormat(str, Enum):
    """
    Format of message.
    """
    MESSAGE_FORMAT_UNSPECIFIED = "MESSAGE_FORMAT_UNSPECIFIED"
    PROTO = "PROTO"
    JSON = "JSON"


class GoogleCloudDialogflowV2SpeechToTextConfigSpeechModelVariant(str, Enum):
    """
    Optional. The speech model used in speech to text. `SPEECH_MODEL_VARIANT_UNSPECIFIED`, `USE_BEST_AVAILABLE` will be treated as `USE_ENHANCED`. It can be overridden in AnalyzeContentRequest and StreamingAnalyzeContentRequest request.
    """
    SPEECH_MODEL_VARIANT_UNSPECIFIED = "SPEECH_MODEL_VARIANT_UNSPECIFIED"
    USE_BEST_AVAILABLE = "USE_BEST_AVAILABLE"
    USE_STANDARD = "USE_STANDARD"
    USE_ENHANCED = "USE_ENHANCED"


class GoogleCloudDialogflowV2SuggestionFeatureType(str, Enum):
    """
    Type of Human Agent Assistant API feature to request.
    """
    TYPE_UNSPECIFIED = "TYPE_UNSPECIFIED"
    ARTICLE_SUGGESTION = "ARTICLE_SUGGESTION"
    FAQ = "FAQ"


class GoogleCloudDialogflowV2TextToSpeechSettingsOutputAudioEncoding(str, Enum):
    """
    Required. Audio encoding of the synthesized audio content.
    """
    OUTPUT_AUDIO_ENCODING_UNSPECIFIED = "OUTPUT_AUDIO_ENCODING_UNSPECIFIED"
    OUTPUT_AUDIO_ENCODING_LINEAR16 = "OUTPUT_AUDIO_ENCODING_LINEAR_16"
    OUTPUT_AUDIO_ENCODING_MP3 = "OUTPUT_AUDIO_ENCODING_MP3"
    OUTPUT_AUDIO_ENCODING_MP364_KBPS = "OUTPUT_AUDIO_ENCODING_MP3_64_KBPS"
    OUTPUT_AUDIO_ENCODING_OGG_OPUS = "OUTPUT_AUDIO_ENCODING_OGG_OPUS"
    OUTPUT_AUDIO_ENCODING_MULAW = "OUTPUT_AUDIO_ENCODING_MULAW"


class IntentDefaultResponsePlatformsItem(str, Enum):
    PLATFORM_UNSPECIFIED = "PLATFORM_UNSPECIFIED"
    FACEBOOK = "FACEBOOK"
    SLACK = "SLACK"
    TELEGRAM = "TELEGRAM"
    KIK = "KIK"
    SKYPE = "SKYPE"
    LINE = "LINE"
    VIBER = "VIBER"
    ACTIONS_ON_GOOGLE = "ACTIONS_ON_GOOGLE"
    GOOGLE_HANGOUTS = "GOOGLE_HANGOUTS"


class IntentWebhookState(str, Enum):
    """
    Optional. Indicates whether webhooks are enabled for the intent.
    """
    WEBHOOK_STATE_UNSPECIFIED = "WEBHOOK_STATE_UNSPECIFIED"
    WEBHOOK_STATE_ENABLED = "WEBHOOK_STATE_ENABLED"
    WEBHOOK_STATE_ENABLED_FOR_SLOT_FILLING = "WEBHOOK_STATE_ENABLED_FOR_SLOT_FILLING"


class ParticipantRole(str, Enum):
    """
    Immutable. The role this participant plays in the conversation. This field must be set during participant creation and is then immutable.
    """
    ROLE_UNSPECIFIED = "ROLE_UNSPECIFIED"
    HUMAN_AGENT = "HUMAN_AGENT"
    AUTOMATED_AGENT = "AUTOMATED_AGENT"
    END_USER = "END_USER"


class SessionEntityTypeEntityOverrideMode(str, Enum):
    """
    Required. Indicates whether the additional data should override or supplement the custom entity type definition.
    """
    ENTITY_OVERRIDE_MODE_UNSPECIFIED = "ENTITY_OVERRIDE_MODE_UNSPECIFIED"
    ENTITY_OVERRIDE_MODE_OVERRIDE = "ENTITY_OVERRIDE_MODE_OVERRIDE"
    ENTITY_OVERRIDE_MODE_SUPPLEMENT = "ENTITY_OVERRIDE_MODE_SUPPLEMENT"
