# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'EntityTypeAutoExpansionMode',
    'EntityTypeKind',
    'ExperimentState',
    'GoogleCloudDialogflowCxV3beta1ExperimentResultMetricCountType',
    'GoogleCloudDialogflowCxV3beta1ExperimentResultMetricType',
    'GoogleCloudDialogflowCxV3beta1InputAudioConfigAudioEncoding',
    'GoogleCloudDialogflowCxV3beta1InputAudioConfigModelVariant',
    'GoogleCloudDialogflowCxV3beta1NluSettingsModelTrainingMode',
    'GoogleCloudDialogflowCxV3beta1NluSettingsModelType',
    'GoogleCloudDialogflowCxV3beta1TestCaseResultTestResult',
    'SecuritySettingPurgeDataTypesItem',
    'SecuritySettingRedactionScope',
    'SecuritySettingRedactionStrategy',
    'SessionEntityTypeEntityOverrideMode',
]


class EntityTypeAutoExpansionMode(str, Enum):
    """
    Indicates whether the entity type can be automatically expanded.
    """
    AUTO_EXPANSION_MODE_UNSPECIFIED = "AUTO_EXPANSION_MODE_UNSPECIFIED"
    AUTO_EXPANSION_MODE_DEFAULT = "AUTO_EXPANSION_MODE_DEFAULT"


class EntityTypeKind(str, Enum):
    """
    Required. Indicates the kind of entity type.
    """
    KIND_UNSPECIFIED = "KIND_UNSPECIFIED"
    KIND_MAP = "KIND_MAP"
    KIND_LIST = "KIND_LIST"
    KIND_REGEXP = "KIND_REGEXP"


class ExperimentState(str, Enum):
    """
    The current state of the experiment. Transition triggered by Expriments.StartExperiment: PENDING->RUNNING. Transition triggered by Expriments.CancelExperiment: PENDING->CANCELLED or RUNNING->CANCELLED.
    """
    STATE_UNSPECIFIED = "STATE_UNSPECIFIED"
    DRAFT = "DRAFT"
    RUNNING = "RUNNING"
    DONE = "DONE"


class GoogleCloudDialogflowCxV3beta1ExperimentResultMetricCountType(str, Enum):
    """
    Count-based metric type. Only one of type or count_type is specified in each Metric.
    """
    COUNT_TYPE_UNSPECIFIED = "COUNT_TYPE_UNSPECIFIED"
    TOTAL_NO_MATCH_COUNT = "TOTAL_NO_MATCH_COUNT"
    TOTAL_TURN_COUNT = "TOTAL_TURN_COUNT"
    AVERAGE_TURN_COUNT = "AVERAGE_TURN_COUNT"


class GoogleCloudDialogflowCxV3beta1ExperimentResultMetricType(str, Enum):
    """
    Ratio-based metric type. Only one of type or count_type is specified in each Metric.
    """
    METRIC_UNSPECIFIED = "METRIC_UNSPECIFIED"
    CONTAINED_SESSION_NO_CALLBACK_RATE = "CONTAINED_SESSION_NO_CALLBACK_RATE"
    LIVE_AGENT_HANDOFF_RATE = "LIVE_AGENT_HANDOFF_RATE"
    CALLBACK_SESSION_RATE = "CALLBACK_SESSION_RATE"
    ABANDONED_SESSION_RATE = "ABANDONED_SESSION_RATE"
    SESSION_END_RATE = "SESSION_END_RATE"


class GoogleCloudDialogflowCxV3beta1InputAudioConfigAudioEncoding(str, Enum):
    """
    Required. Audio encoding of the audio content to process.
    """
    AUDIO_ENCODING_UNSPECIFIED = "AUDIO_ENCODING_UNSPECIFIED"
    AUDIO_ENCODING_LINEAR16 = "AUDIO_ENCODING_LINEAR_16"
    AUDIO_ENCODING_FLAC = "AUDIO_ENCODING_FLAC"
    AUDIO_ENCODING_MULAW = "AUDIO_ENCODING_MULAW"
    AUDIO_ENCODING_AMR = "AUDIO_ENCODING_AMR"
    AUDIO_ENCODING_AMR_WB = "AUDIO_ENCODING_AMR_WB"
    AUDIO_ENCODING_OGG_OPUS = "AUDIO_ENCODING_OGG_OPUS"
    AUDIO_ENCODING_SPEEX_WITH_HEADER_BYTE = "AUDIO_ENCODING_SPEEX_WITH_HEADER_BYTE"


class GoogleCloudDialogflowCxV3beta1InputAudioConfigModelVariant(str, Enum):
    """
    Optional. Which variant of the Speech model to use.
    """
    SPEECH_MODEL_VARIANT_UNSPECIFIED = "SPEECH_MODEL_VARIANT_UNSPECIFIED"
    USE_BEST_AVAILABLE = "USE_BEST_AVAILABLE"
    USE_STANDARD = "USE_STANDARD"
    USE_ENHANCED = "USE_ENHANCED"


class GoogleCloudDialogflowCxV3beta1NluSettingsModelTrainingMode(str, Enum):
    """
    Indicates NLU model training mode.
    """
    MODEL_TRAINING_MODE_UNSPECIFIED = "MODEL_TRAINING_MODE_UNSPECIFIED"
    MODEL_TRAINING_MODE_AUTOMATIC = "MODEL_TRAINING_MODE_AUTOMATIC"
    MODEL_TRAINING_MODE_MANUAL = "MODEL_TRAINING_MODE_MANUAL"


class GoogleCloudDialogflowCxV3beta1NluSettingsModelType(str, Enum):
    """
    Indicates the type of NLU model.
    """
    MODEL_TYPE_UNSPECIFIED = "MODEL_TYPE_UNSPECIFIED"
    MODEL_TYPE_STANDARD = "MODEL_TYPE_STANDARD"
    MODEL_TYPE_ADVANCED = "MODEL_TYPE_ADVANCED"


class GoogleCloudDialogflowCxV3beta1TestCaseResultTestResult(str, Enum):
    """
    Whether the test case passed in the agent environment.
    """
    TEST_RESULT_UNSPECIFIED = "TEST_RESULT_UNSPECIFIED"
    PASSED = "PASSED"
    FAILED = "FAILED"


class SecuritySettingPurgeDataTypesItem(str, Enum):
    PURGE_DATA_TYPE_UNSPECIFIED = "PURGE_DATA_TYPE_UNSPECIFIED"
    DIALOGFLOW_HISTORY = "DIALOGFLOW_HISTORY"


class SecuritySettingRedactionScope(str, Enum):
    """
    Defines on what data we apply redaction. Note that we don't redact data to which we don't have access, e.g., Stackdriver logs.
    """
    REDACTION_SCOPE_UNSPECIFIED = "REDACTION_SCOPE_UNSPECIFIED"
    REDACT_DISK_STORAGE = "REDACT_DISK_STORAGE"


class SecuritySettingRedactionStrategy(str, Enum):
    """
    Strategy that defines how we do redaction.
    """
    REDACTION_STRATEGY_UNSPECIFIED = "REDACTION_STRATEGY_UNSPECIFIED"
    REDACT_WITH_SERVICE = "REDACT_WITH_SERVICE"


class SessionEntityTypeEntityOverrideMode(str, Enum):
    """
    Required. Indicates whether the additional data should override or supplement the custom entity type definition.
    """
    ENTITY_OVERRIDE_MODE_UNSPECIFIED = "ENTITY_OVERRIDE_MODE_UNSPECIFIED"
    ENTITY_OVERRIDE_MODE_OVERRIDE = "ENTITY_OVERRIDE_MODE_OVERRIDE"
    ENTITY_OVERRIDE_MODE_SUPPLEMENT = "ENTITY_OVERRIDE_MODE_SUPPLEMENT"
