# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AptRepositoryArchiveType',
    'AptSettingsType',
    'ExecStepConfigInterpreter',
    'PackageDesiredState',
    'PackageManager',
    'PatchConfigRebootConfig',
    'PatchRolloutMode',
    'RecurringScheduleFrequency',
    'SoftwareRecipeDesiredState',
    'SoftwareRecipeStepExtractArchiveType',
    'SoftwareRecipeStepRunScriptInterpreter',
    'WeekDayOfMonthDayOfWeek',
    'WeeklyScheduleDayOfWeek',
    'WindowsUpdateSettingsClassificationsItem',
]


class AptRepositoryArchiveType(str, Enum):
    """
    Type of archive files in this repository. The default behavior is DEB.
    """
    ARCHIVE_TYPE_UNSPECIFIED = "ARCHIVE_TYPE_UNSPECIFIED"
    DEB = "DEB"
    DEB_SRC = "DEB_SRC"


class AptSettingsType(str, Enum):
    """
    By changing the type to DIST, the patching is performed using `apt-get dist-upgrade` instead.
    """
    TYPE_UNSPECIFIED = "TYPE_UNSPECIFIED"
    DIST = "DIST"
    UPGRADE = "UPGRADE"


class ExecStepConfigInterpreter(str, Enum):
    """
    The script interpreter to use to run the script. If no interpreter is specified the script will be executed directly, which will likely only succeed for scripts with [shebang lines] (https://en.wikipedia.org/wiki/Shebang_\(Unix\)).
    """
    INTERPRETER_UNSPECIFIED = "INTERPRETER_UNSPECIFIED"
    SHELL = "SHELL"
    POWERSHELL = "POWERSHELL"


class PackageDesiredState(str, Enum):
    """
    The desired_state the agent should maintain for this package. The default is to ensure the package is installed.
    """
    DESIRED_STATE_UNSPECIFIED = "DESIRED_STATE_UNSPECIFIED"
    INSTALLED = "INSTALLED"
    UPDATED = "UPDATED"
    REMOVED = "REMOVED"


class PackageManager(str, Enum):
    """
    Type of package manager that can be used to install this package. If a system does not have the package manager, the package is not installed or removed no error message is returned. By default, or if you specify `ANY`, the agent attempts to install and remove this package using the default package manager. This is useful when creating a policy that applies to different types of systems. The default behavior is ANY.
    """
    MANAGER_UNSPECIFIED = "MANAGER_UNSPECIFIED"
    ANY = "ANY"
    APT = "APT"
    YUM = "YUM"
    ZYPPER = "ZYPPER"
    GOO = "GOO"


class PatchConfigRebootConfig(str, Enum):
    """
    Post-patch reboot settings.
    """
    REBOOT_CONFIG_UNSPECIFIED = "REBOOT_CONFIG_UNSPECIFIED"
    DEFAULT = "DEFAULT"
    ALWAYS = "ALWAYS"
    NEVER = "NEVER"


class PatchRolloutMode(str, Enum):
    """
    Mode of the patch rollout.
    """
    MODE_UNSPECIFIED = "MODE_UNSPECIFIED"
    ZONE_BY_ZONE = "ZONE_BY_ZONE"
    CONCURRENT_ZONES = "CONCURRENT_ZONES"


class RecurringScheduleFrequency(str, Enum):
    """
    Required. The frequency unit of this recurring schedule.
    """
    FREQUENCY_UNSPECIFIED = "FREQUENCY_UNSPECIFIED"
    WEEKLY = "WEEKLY"
    MONTHLY = "MONTHLY"


class SoftwareRecipeDesiredState(str, Enum):
    """
    Default is INSTALLED. The desired state the agent should maintain for this recipe. INSTALLED: The software recipe is installed on the instance but won't be updated to new versions. UPDATED: The software recipe is installed on the instance. The recipe is updated to a higher version, if a higher version of the recipe is assigned to this instance. REMOVE: Remove is unsupported for software recipes and attempts to create or update a recipe to the REMOVE state is rejected.
    """
    DESIRED_STATE_UNSPECIFIED = "DESIRED_STATE_UNSPECIFIED"
    INSTALLED = "INSTALLED"
    UPDATED = "UPDATED"
    REMOVED = "REMOVED"


class SoftwareRecipeStepExtractArchiveType(str, Enum):
    """
    Required. The type of the archive to extract.
    """
    ARCHIVE_TYPE_UNSPECIFIED = "ARCHIVE_TYPE_UNSPECIFIED"
    TAR = "TAR"
    TAR_GZIP = "TAR_GZIP"
    TAR_BZIP = "TAR_BZIP"
    TAR_LZMA = "TAR_LZMA"
    TAR_XZ = "TAR_XZ"
    ZIP = "ZIP"


class SoftwareRecipeStepRunScriptInterpreter(str, Enum):
    """
    The script interpreter to use to run the script. If no interpreter is specified the script is executed directly, which likely only succeed for scripts with [shebang lines](https://en.wikipedia.org/wiki/Shebang_\(Unix\)).
    """
    INTERPRETER_UNSPECIFIED = "INTERPRETER_UNSPECIFIED"
    SHELL = "SHELL"
    POWERSHELL = "POWERSHELL"


class WeekDayOfMonthDayOfWeek(str, Enum):
    """
    Required. A day of the week.
    """
    DAY_OF_WEEK_UNSPECIFIED = "DAY_OF_WEEK_UNSPECIFIED"
    MONDAY = "MONDAY"
    TUESDAY = "TUESDAY"
    WEDNESDAY = "WEDNESDAY"
    THURSDAY = "THURSDAY"
    FRIDAY = "FRIDAY"
    SATURDAY = "SATURDAY"
    SUNDAY = "SUNDAY"


class WeeklyScheduleDayOfWeek(str, Enum):
    """
    Required. Day of the week.
    """
    DAY_OF_WEEK_UNSPECIFIED = "DAY_OF_WEEK_UNSPECIFIED"
    MONDAY = "MONDAY"
    TUESDAY = "TUESDAY"
    WEDNESDAY = "WEDNESDAY"
    THURSDAY = "THURSDAY"
    FRIDAY = "FRIDAY"
    SATURDAY = "SATURDAY"
    SUNDAY = "SUNDAY"


class WindowsUpdateSettingsClassificationsItem(str, Enum):
    CLASSIFICATION_UNSPECIFIED = "CLASSIFICATION_UNSPECIFIED"
    CRITICAL = "CRITICAL"
    SECURITY = "SECURITY"
    DEFINITION = "DEFINITION"
    DRIVER = "DRIVER"
    FEATURE_PACK = "FEATURE_PACK"
    SERVICE_PACK = "SERVICE_PACK"
    TOOL = "TOOL"
    UPDATE_ROLLUP = "UPDATE_ROLLUP"
    UPDATE = "UPDATE"
