# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'BackupRetentionSettingsRetentionUnit',
    'BackupRunBackupKind',
    'BackupRunStatus',
    'BackupRunType',
    'InstanceBackendType',
    'InstanceDatabaseVersion',
    'InstanceInstanceType',
    'InstanceState',
    'InstanceSuspensionReasonItem',
    'IpMappingType',
    'MaintenanceWindowUpdateTrack',
    'SettingsActivationPolicy',
    'SettingsAvailabilityType',
    'SettingsDataDiskType',
    'SettingsPricingPlan',
    'SqlOutOfDiskReportSqlOutOfDiskState',
]


class BackupRetentionSettingsRetentionUnit(str, Enum):
    """
    The unit that 'retained_backups' represents.
    """
    RETENTION_UNIT_UNSPECIFIED = "RETENTION_UNIT_UNSPECIFIED"
    COUNT = "COUNT"


class BackupRunBackupKind(str, Enum):
    """
    Specifies the kind of backup, PHYSICAL or DEFAULT_SNAPSHOT.
    """
    SQL_BACKUP_KIND_UNSPECIFIED = "SQL_BACKUP_KIND_UNSPECIFIED"
    SNAPSHOT = "SNAPSHOT"
    PHYSICAL = "PHYSICAL"


class BackupRunStatus(str, Enum):
    """
    The status of this run.
    """
    SQL_BACKUP_RUN_STATUS_UNSPECIFIED = "SQL_BACKUP_RUN_STATUS_UNSPECIFIED"
    ENQUEUED = "ENQUEUED"
    OVERDUE = "OVERDUE"
    RUNNING = "RUNNING"
    FAILED = "FAILED"
    SUCCESSFUL = "SUCCESSFUL"
    SKIPPED = "SKIPPED"
    DELETION_PENDING = "DELETION_PENDING"
    DELETION_FAILED = "DELETION_FAILED"
    DELETED = "DELETED"


class BackupRunType(str, Enum):
    """
    The type of this run; can be either "AUTOMATED" or "ON_DEMAND". This field defaults to "ON_DEMAND" and is ignored, when specified for insert requests.
    """
    SQL_BACKUP_RUN_TYPE_UNSPECIFIED = "SQL_BACKUP_RUN_TYPE_UNSPECIFIED"
    AUTOMATED = "AUTOMATED"
    ON_DEMAND = "ON_DEMAND"


class InstanceBackendType(str, Enum):
    """
     *SECOND_GEN*: Cloud SQL database instance. *EXTERNAL*: A database server that is not managed by Google. This property is read-only; use the *tier* property in the *settings* object to determine the database type.
    """
    SQL_BACKEND_TYPE_UNSPECIFIED = "SQL_BACKEND_TYPE_UNSPECIFIED"
    FIRST_GEN = "FIRST_GEN"
    SECOND_GEN = "SECOND_GEN"
    EXTERNAL = "EXTERNAL"


class InstanceDatabaseVersion(str, Enum):
    """
    The database engine type and version. The *databaseVersion* field cannot be changed after instance creation. MySQL instances: *MYSQL_8_0*, *MYSQL_5_7* (default), or *MYSQL_5_6*. PostgreSQL instances: *POSTGRES_9_6*, *POSTGRES_10*, *POSTGRES_11*, *POSTGRES_12*, or *POSTGRES_13* (default). SQL Server instances: *SQLSERVER_2017_STANDARD* (default), *SQLSERVER_2017_ENTERPRISE*, *SQLSERVER_2017_EXPRESS*, or *SQLSERVER_2017_WEB*.
    """
    SQL_DATABASE_VERSION_UNSPECIFIED = "SQL_DATABASE_VERSION_UNSPECIFIED"
    MYSQL51 = "MYSQL_5_1"
    MYSQL55 = "MYSQL_5_5"
    MYSQL56 = "MYSQL_5_6"
    MYSQL57 = "MYSQL_5_7"
    POSTGRES96 = "POSTGRES_9_6"
    POSTGRES11 = "POSTGRES_11"
    SQLSERVER2017_STANDARD = "SQLSERVER_2017_STANDARD"
    SQLSERVER2017_ENTERPRISE = "SQLSERVER_2017_ENTERPRISE"
    SQLSERVER2017_EXPRESS = "SQLSERVER_2017_EXPRESS"
    SQLSERVER2017_WEB = "SQLSERVER_2017_WEB"
    POSTGRES10 = "POSTGRES_10"
    POSTGRES12 = "POSTGRES_12"
    MYSQL80 = "MYSQL_8_0"
    POSTGRES13 = "POSTGRES_13"


class InstanceInstanceType(str, Enum):
    """
    The instance type. This can be one of the following. *CLOUD_SQL_INSTANCE*: A Cloud SQL instance that is not replicating from a primary instance. *ON_PREMISES_INSTANCE*: An instance running on the customer's premises. *READ_REPLICA_INSTANCE*: A Cloud SQL instance configured as a read-replica.
    """
    SQL_INSTANCE_TYPE_UNSPECIFIED = "SQL_INSTANCE_TYPE_UNSPECIFIED"
    CLOUD_SQL_INSTANCE = "CLOUD_SQL_INSTANCE"
    ON_PREMISES_INSTANCE = "ON_PREMISES_INSTANCE"
    READ_REPLICA_INSTANCE = "READ_REPLICA_INSTANCE"


class InstanceState(str, Enum):
    """
    The current serving state of the Cloud SQL instance. This can be one of the following. *SQL_INSTANCE_STATE_UNSPECIFIED*: The state of the instance is unknown. *RUNNABLE*: The instance is running, or has been stopped by owner. *SUSPENDED*: The instance is not available, for example due to problems with billing. *PENDING_DELETE*: The instance is being deleted. *PENDING_CREATE*: The instance is being created. *MAINTENANCE*: The instance is down for maintenance. *FAILED*: The instance creation failed.
    """
    SQL_INSTANCE_STATE_UNSPECIFIED = "SQL_INSTANCE_STATE_UNSPECIFIED"
    RUNNABLE = "RUNNABLE"
    SUSPENDED = "SUSPENDED"
    PENDING_DELETE = "PENDING_DELETE"
    PENDING_CREATE = "PENDING_CREATE"
    MAINTENANCE = "MAINTENANCE"
    FAILED = "FAILED"


class InstanceSuspensionReasonItem(str, Enum):
    SQL_SUSPENSION_REASON_UNSPECIFIED = "SQL_SUSPENSION_REASON_UNSPECIFIED"
    BILLING_ISSUE = "BILLING_ISSUE"
    LEGAL_ISSUE = "LEGAL_ISSUE"
    OPERATIONAL_ISSUE = "OPERATIONAL_ISSUE"
    KMS_KEY_ISSUE = "KMS_KEY_ISSUE"


class IpMappingType(str, Enum):
    """
    The type of this IP address. A *PRIMARY* address is a public address that can accept incoming connections. A *PRIVATE* address is a private address that can accept incoming connections. An *OUTGOING* address is the source address of connections originating from the instance, if supported.
    """
    SQL_IP_ADDRESS_TYPE_UNSPECIFIED = "SQL_IP_ADDRESS_TYPE_UNSPECIFIED"
    PRIMARY = "PRIMARY"
    OUTGOING = "OUTGOING"
    PRIVATE = "PRIVATE"
    MIGRATED1ST_GEN = "MIGRATED_1ST_GEN"


class MaintenanceWindowUpdateTrack(str, Enum):
    """
    Maintenance timing setting: *canary* (Earlier) or *stable* (Later). Learn more.
    """
    SQL_UPDATE_TRACK_UNSPECIFIED = "SQL_UPDATE_TRACK_UNSPECIFIED"
    CANARY = "canary"
    STABLE = "stable"


class SettingsActivationPolicy(str, Enum):
    """
    The activation policy specifies when the instance is activated; it is applicable only when the instance state is RUNNABLE. Valid values: *ALWAYS*: The instance is on, and remains so even in the absence of connection requests. *NEVER*: The instance is off; it is not activated, even if a connection request arrives.
    """
    SQL_ACTIVATION_POLICY_UNSPECIFIED = "SQL_ACTIVATION_POLICY_UNSPECIFIED"
    ALWAYS = "ALWAYS"
    NEVER = "NEVER"
    ON_DEMAND = "ON_DEMAND"


class SettingsAvailabilityType(str, Enum):
    """
    Availability type. Potential values: *ZONAL*: The instance serves data from only one zone. Outages in that zone affect data accessibility. *REGIONAL*: The instance can serve data from more than one zone in a region (it is highly available). For more information, see Overview of the High Availability Configuration.
    """
    SQL_AVAILABILITY_TYPE_UNSPECIFIED = "SQL_AVAILABILITY_TYPE_UNSPECIFIED"
    ZONAL = "ZONAL"
    REGIONAL = "REGIONAL"


class SettingsDataDiskType(str, Enum):
    """
    The type of data disk: PD_SSD (default) or PD_HDD. Not used for First Generation instances.
    """
    SQL_DATA_DISK_TYPE_UNSPECIFIED = "SQL_DATA_DISK_TYPE_UNSPECIFIED"
    PD_SSD = "PD_SSD"
    PD_HDD = "PD_HDD"
    OBSOLETE_LOCAL_SSD = "OBSOLETE_LOCAL_SSD"


class SettingsPricingPlan(str, Enum):
    """
    The pricing plan for this instance. This can be either *PER_USE* or *PACKAGE*. Only *PER_USE* is supported for Second Generation instances.
    """
    SQL_PRICING_PLAN_UNSPECIFIED = "SQL_PRICING_PLAN_UNSPECIFIED"
    PACKAGE = "PACKAGE"
    PER_USE = "PER_USE"


class SqlOutOfDiskReportSqlOutOfDiskState(str, Enum):
    """
    This field represents the state generated by the proactive database wellness job for OutOfDisk issues. Writers: -- the proactive database wellness job for OOD. Readers: -- the Pantheon frontend -- the proactive database wellness job
    """
    SQL_OUT_OF_DISK_STATE_UNSPECIFIED = "SQL_OUT_OF_DISK_STATE_UNSPECIFIED"
    NORMAL = "NORMAL"
    SOFT_SHUTDOWN = "SOFT_SHUTDOWN"
