# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AndroidInstrumentationTestOrchestratorOption',
    'RoboDirectiveActionType',
    'TestExecutionState',
    'TestMatrixInvalidMatrixDetails',
    'TestMatrixOutcomeSummary',
    'TestMatrixState',
]


class AndroidInstrumentationTestOrchestratorOption(str, Enum):
    """
    The option of whether running each test within its own invocation of instrumentation with Android Test Orchestrator or not. ** Orchestrator is only compatible with AndroidJUnitRunner version 1.0 or higher! ** Orchestrator offers the following benefits: - No shared state - Crashes are isolated - Logs are scoped per test See for more information about Android Test Orchestrator. If not set, the test will be run without the orchestrator.
    """
    ORCHESTRATOR_OPTION_UNSPECIFIED = "ORCHESTRATOR_OPTION_UNSPECIFIED"
    USE_ORCHESTRATOR = "USE_ORCHESTRATOR"
    DO_NOT_USE_ORCHESTRATOR = "DO_NOT_USE_ORCHESTRATOR"


class RoboDirectiveActionType(str, Enum):
    """
    Required. The type of action that Robo should perform on the specified element.
    """
    ACTION_TYPE_UNSPECIFIED = "ACTION_TYPE_UNSPECIFIED"
    SINGLE_CLICK = "SINGLE_CLICK"
    ENTER_TEXT = "ENTER_TEXT"
    IGNORE = "IGNORE"


class TestExecutionState(str, Enum):
    """
    Output only. Indicates the current progress of the test execution (e.g., FINISHED).
    """
    TEST_STATE_UNSPECIFIED = "TEST_STATE_UNSPECIFIED"
    VALIDATING = "VALIDATING"
    PENDING = "PENDING"
    RUNNING = "RUNNING"
    FINISHED = "FINISHED"
    ERROR = "ERROR"
    UNSUPPORTED_ENVIRONMENT = "UNSUPPORTED_ENVIRONMENT"
    INCOMPATIBLE_ENVIRONMENT = "INCOMPATIBLE_ENVIRONMENT"
    INCOMPATIBLE_ARCHITECTURE = "INCOMPATIBLE_ARCHITECTURE"
    CANCELLED = "CANCELLED"
    INVALID = "INVALID"


class TestMatrixInvalidMatrixDetails(str, Enum):
    """
    Output only. Describes why the matrix is considered invalid. Only useful for matrices in the INVALID state.
    """
    INVALID_MATRIX_DETAILS_UNSPECIFIED = "INVALID_MATRIX_DETAILS_UNSPECIFIED"
    DETAILS_UNAVAILABLE = "DETAILS_UNAVAILABLE"
    MALFORMED_APK = "MALFORMED_APK"
    MALFORMED_TEST_APK = "MALFORMED_TEST_APK"
    NO_MANIFEST = "NO_MANIFEST"
    NO_PACKAGE_NAME = "NO_PACKAGE_NAME"
    INVALID_PACKAGE_NAME = "INVALID_PACKAGE_NAME"
    TEST_SAME_AS_APP = "TEST_SAME_AS_APP"
    NO_INSTRUMENTATION = "NO_INSTRUMENTATION"
    NO_SIGNATURE = "NO_SIGNATURE"
    INSTRUMENTATION_ORCHESTRATOR_INCOMPATIBLE = "INSTRUMENTATION_ORCHESTRATOR_INCOMPATIBLE"
    NO_TEST_RUNNER_CLASS = "NO_TEST_RUNNER_CLASS"
    NO_LAUNCHER_ACTIVITY = "NO_LAUNCHER_ACTIVITY"
    FORBIDDEN_PERMISSIONS = "FORBIDDEN_PERMISSIONS"
    INVALID_ROBO_DIRECTIVES = "INVALID_ROBO_DIRECTIVES"
    INVALID_RESOURCE_NAME = "INVALID_RESOURCE_NAME"
    INVALID_DIRECTIVE_ACTION = "INVALID_DIRECTIVE_ACTION"
    TEST_LOOP_INTENT_FILTER_NOT_FOUND = "TEST_LOOP_INTENT_FILTER_NOT_FOUND"
    SCENARIO_LABEL_NOT_DECLARED = "SCENARIO_LABEL_NOT_DECLARED"
    SCENARIO_LABEL_MALFORMED = "SCENARIO_LABEL_MALFORMED"
    SCENARIO_NOT_DECLARED = "SCENARIO_NOT_DECLARED"
    DEVICE_ADMIN_RECEIVER = "DEVICE_ADMIN_RECEIVER"
    MALFORMED_XC_TEST_ZIP = "MALFORMED_XC_TEST_ZIP"
    BUILT_FOR_IOS_SIMULATOR = "BUILT_FOR_IOS_SIMULATOR"
    NO_TESTS_IN_XC_TEST_ZIP = "NO_TESTS_IN_XC_TEST_ZIP"
    USE_DESTINATION_ARTIFACTS = "USE_DESTINATION_ARTIFACTS"
    TEST_NOT_APP_HOSTED = "TEST_NOT_APP_HOSTED"
    PLIST_CANNOT_BE_PARSED = "PLIST_CANNOT_BE_PARSED"
    TEST_ONLY_APK = "TEST_ONLY_APK"
    MALFORMED_IPA = "MALFORMED_IPA"
    MISSING_URL_SCHEME = "MISSING_URL_SCHEME"
    MALFORMED_APP_BUNDLE = "MALFORMED_APP_BUNDLE"
    NO_CODE_APK = "NO_CODE_APK"
    INVALID_INPUT_APK = "INVALID_INPUT_APK"
    INVALID_APK_PREVIEW_SDK = "INVALID_APK_PREVIEW_SDK"


class TestMatrixOutcomeSummary(str, Enum):
    """
    Output Only. The overall outcome of the test. Only set when the test matrix state is FINISHED.
    """
    OUTCOME_SUMMARY_UNSPECIFIED = "OUTCOME_SUMMARY_UNSPECIFIED"
    SUCCESS = "SUCCESS"
    FAILURE = "FAILURE"
    INCONCLUSIVE = "INCONCLUSIVE"
    SKIPPED = "SKIPPED"


class TestMatrixState(str, Enum):
    """
    Output only. Indicates the current progress of the test matrix.
    """
    TEST_STATE_UNSPECIFIED = "TEST_STATE_UNSPECIFIED"
    VALIDATING = "VALIDATING"
    PENDING = "PENDING"
    RUNNING = "RUNNING"
    FINISHED = "FINISHED"
    ERROR = "ERROR"
    UNSUPPORTED_ENVIRONMENT = "UNSUPPORTED_ENVIRONMENT"
    INCOMPATIBLE_ENVIRONMENT = "INCOMPATIBLE_ENVIRONMENT"
    INCOMPATIBLE_ARCHITECTURE = "INCOMPATIBLE_ARCHITECTURE"
    CANCELLED = "CANCELLED"
    INVALID = "INVALID"
