# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'ScanConfigErrorCode',
    'ScanConfigExportToSecurityCommandCenter',
    'ScanConfigRiskLevel',
    'ScanConfigTargetPlatformsItem',
    'ScanConfigUserAgent',
    'ScanRunErrorTraceCode',
    'ScanRunExecutionState',
    'ScanRunResultState',
    'ScanRunWarningTraceCode',
]


class ScanConfigErrorCode(str, Enum):
    """
    Indicates the reason code for a configuration failure.
    """
    CODE_UNSPECIFIED = "CODE_UNSPECIFIED"
    OK = "OK"
    INTERNAL_ERROR = "INTERNAL_ERROR"
    APPENGINE_API_BACKEND_ERROR = "APPENGINE_API_BACKEND_ERROR"
    APPENGINE_API_NOT_ACCESSIBLE = "APPENGINE_API_NOT_ACCESSIBLE"
    APPENGINE_DEFAULT_HOST_MISSING = "APPENGINE_DEFAULT_HOST_MISSING"
    CANNOT_USE_GOOGLE_COM_ACCOUNT = "CANNOT_USE_GOOGLE_COM_ACCOUNT"
    CANNOT_USE_OWNER_ACCOUNT = "CANNOT_USE_OWNER_ACCOUNT"
    COMPUTE_API_BACKEND_ERROR = "COMPUTE_API_BACKEND_ERROR"
    COMPUTE_API_NOT_ACCESSIBLE = "COMPUTE_API_NOT_ACCESSIBLE"
    CUSTOM_LOGIN_URL_DOES_NOT_BELONG_TO_CURRENT_PROJECT = "CUSTOM_LOGIN_URL_DOES_NOT_BELONG_TO_CURRENT_PROJECT"
    CUSTOM_LOGIN_URL_MALFORMED = "CUSTOM_LOGIN_URL_MALFORMED"
    CUSTOM_LOGIN_URL_MAPPED_TO_NON_ROUTABLE_ADDRESS = "CUSTOM_LOGIN_URL_MAPPED_TO_NON_ROUTABLE_ADDRESS"
    CUSTOM_LOGIN_URL_MAPPED_TO_UNRESERVED_ADDRESS = "CUSTOM_LOGIN_URL_MAPPED_TO_UNRESERVED_ADDRESS"
    CUSTOM_LOGIN_URL_HAS_NON_ROUTABLE_IP_ADDRESS = "CUSTOM_LOGIN_URL_HAS_NON_ROUTABLE_IP_ADDRESS"
    CUSTOM_LOGIN_URL_HAS_UNRESERVED_IP_ADDRESS = "CUSTOM_LOGIN_URL_HAS_UNRESERVED_IP_ADDRESS"
    DUPLICATE_SCAN_NAME = "DUPLICATE_SCAN_NAME"
    INVALID_FIELD_VALUE = "INVALID_FIELD_VALUE"
    FAILED_TO_AUTHENTICATE_TO_TARGET = "FAILED_TO_AUTHENTICATE_TO_TARGET"
    FINDING_TYPE_UNSPECIFIED = "FINDING_TYPE_UNSPECIFIED"
    FORBIDDEN_TO_SCAN_COMPUTE = "FORBIDDEN_TO_SCAN_COMPUTE"
    FORBIDDEN_UPDATE_TO_MANAGED_SCAN = "FORBIDDEN_UPDATE_TO_MANAGED_SCAN"
    MALFORMED_FILTER = "MALFORMED_FILTER"
    MALFORMED_RESOURCE_NAME = "MALFORMED_RESOURCE_NAME"
    PROJECT_INACTIVE = "PROJECT_INACTIVE"
    REQUIRED_FIELD = "REQUIRED_FIELD"
    RESOURCE_NAME_INCONSISTENT = "RESOURCE_NAME_INCONSISTENT"
    SCAN_ALREADY_RUNNING = "SCAN_ALREADY_RUNNING"
    SCAN_NOT_RUNNING = "SCAN_NOT_RUNNING"
    SEED_URL_DOES_NOT_BELONG_TO_CURRENT_PROJECT = "SEED_URL_DOES_NOT_BELONG_TO_CURRENT_PROJECT"
    SEED_URL_MALFORMED = "SEED_URL_MALFORMED"
    SEED_URL_MAPPED_TO_NON_ROUTABLE_ADDRESS = "SEED_URL_MAPPED_TO_NON_ROUTABLE_ADDRESS"
    SEED_URL_MAPPED_TO_UNRESERVED_ADDRESS = "SEED_URL_MAPPED_TO_UNRESERVED_ADDRESS"
    SEED_URL_HAS_NON_ROUTABLE_IP_ADDRESS = "SEED_URL_HAS_NON_ROUTABLE_IP_ADDRESS"
    SEED_URL_HAS_UNRESERVED_IP_ADDRESS = "SEED_URL_HAS_UNRESERVED_IP_ADDRESS"
    SERVICE_ACCOUNT_NOT_CONFIGURED = "SERVICE_ACCOUNT_NOT_CONFIGURED"
    TOO_MANY_SCANS = "TOO_MANY_SCANS"
    UNABLE_TO_RESOLVE_PROJECT_INFO = "UNABLE_TO_RESOLVE_PROJECT_INFO"
    UNSUPPORTED_BLACKLIST_PATTERN_FORMAT = "UNSUPPORTED_BLACKLIST_PATTERN_FORMAT"
    UNSUPPORTED_FILTER = "UNSUPPORTED_FILTER"
    UNSUPPORTED_FINDING_TYPE = "UNSUPPORTED_FINDING_TYPE"
    UNSUPPORTED_URL_SCHEME = "UNSUPPORTED_URL_SCHEME"


class ScanConfigExportToSecurityCommandCenter(str, Enum):
    """
    Controls export of scan configurations and results to Security Command Center.
    """
    EXPORT_TO_SECURITY_COMMAND_CENTER_UNSPECIFIED = "EXPORT_TO_SECURITY_COMMAND_CENTER_UNSPECIFIED"
    ENABLED = "ENABLED"
    DISABLED = "DISABLED"


class ScanConfigRiskLevel(str, Enum):
    """
    The risk level selected for the scan
    """
    RISK_LEVEL_UNSPECIFIED = "RISK_LEVEL_UNSPECIFIED"
    NORMAL = "NORMAL"
    LOW = "LOW"


class ScanConfigTargetPlatformsItem(str, Enum):
    TARGET_PLATFORM_UNSPECIFIED = "TARGET_PLATFORM_UNSPECIFIED"
    APP_ENGINE = "APP_ENGINE"
    COMPUTE = "COMPUTE"


class ScanConfigUserAgent(str, Enum):
    """
    The user agent used during scanning.
    """
    USER_AGENT_UNSPECIFIED = "USER_AGENT_UNSPECIFIED"
    CHROME_LINUX = "CHROME_LINUX"
    CHROME_ANDROID = "CHROME_ANDROID"
    SAFARI_IPHONE = "SAFARI_IPHONE"


class ScanRunErrorTraceCode(str, Enum):
    """
    Indicates the error reason code.
    """
    CODE_UNSPECIFIED = "CODE_UNSPECIFIED"
    INTERNAL_ERROR = "INTERNAL_ERROR"
    SCAN_CONFIG_ISSUE = "SCAN_CONFIG_ISSUE"
    AUTHENTICATION_CONFIG_ISSUE = "AUTHENTICATION_CONFIG_ISSUE"
    TIMED_OUT_WHILE_SCANNING = "TIMED_OUT_WHILE_SCANNING"
    TOO_MANY_REDIRECTS = "TOO_MANY_REDIRECTS"
    TOO_MANY_HTTP_ERRORS = "TOO_MANY_HTTP_ERRORS"


class ScanRunExecutionState(str, Enum):
    """
    The execution state of the ScanRun.
    """
    EXECUTION_STATE_UNSPECIFIED = "EXECUTION_STATE_UNSPECIFIED"
    QUEUED = "QUEUED"
    SCANNING = "SCANNING"
    FINISHED = "FINISHED"


class ScanRunResultState(str, Enum):
    """
    The result state of the ScanRun. This field is only available after the execution state reaches "FINISHED".
    """
    RESULT_STATE_UNSPECIFIED = "RESULT_STATE_UNSPECIFIED"
    SUCCESS = "SUCCESS"
    ERROR = "ERROR"
    KILLED = "KILLED"


class ScanRunWarningTraceCode(str, Enum):
    """
    Indicates the warning code.
    """
    CODE_UNSPECIFIED = "CODE_UNSPECIFIED"
    INSUFFICIENT_CRAWL_RESULTS = "INSUFFICIENT_CRAWL_RESULTS"
    TOO_MANY_CRAWL_RESULTS = "TOO_MANY_CRAWL_RESULTS"
    TOO_MANY_FUZZ_TASKS = "TOO_MANY_FUZZ_TASKS"
    BLOCKED_BY_IAP = "BLOCKED_BY_IAP"
    NO_STARTING_URL_FOUND_FOR_MANAGED_SCAN = "NO_STARTING_URL_FOUND_FOR_MANAGED_SCAN"
